#!/usr/bin/perl
# glob_opendir_dumbbench.pl
use v5.10;
use Benchmark::Dumb qw(timethese);
use Cwd qw(cwd);
my( $files, $precision ) = @ARGV;

$files      //= 1000;
$precision  //=    0.05;

use File::Temp qw(tempdir);
my $dir = tempdir( CLEANUP => 1 );

my( $original_cwd ) = cwd();
chdir( $dir ) or die "Could not change to $dir: $!";
foreach ( 1 .. $files ) {
    open my($fh), '>', "$0.$_.tmp" or die "Could not create a file: $!";
    print { $fh } time();
    }

my $count = () = glob( '*' );
printf "$dir has %d files\n", $count;

timethese(
    $precision,
    {
    'Opendir'  => q{ opendir my $dh, "."; my @f = readdir( $dh ) },
    'Glob'     => q{ my @f = glob(".* *") },
    }
    );

chdir( $original_cwd );