#!/usr/bin/perl
# basic_arithmetic_dispatch.pl
use v5.10;
use strict;

use vars qw( %Operators );
%Operators = (
    '+'  => sub { $_[0] + $_[1] },
    '-'  => sub { $_[0] - $_[1] },
    '*'  => sub { $_[0] * $_[1] },
    '/'  => sub { $_[1] ? eval { $_[0] / $_[1] } : 'NaN' },
    );

REPL: while( 1 ) {
    my( $operator, @operand ) = get_line();

    my $some_sub = $Operators{ $operator };
    unless( defined $some_sub ) {
        say "Unknown operator [$operator]";
        last REPL;
        }

    say $Operators{ $operator }->( @operand );
    }

print "Done, exiting...\n";


sub get_line {
    print "\nprompt> ";

    my $line = <STDIN>;

    $line =~ s/^\s+|\s+$//g;

    ( split /\s+/, $line )[1,0,2];
    }